import _regeneratorRuntime from "@babel/runtime/regenerator";

var _marked =
/*#__PURE__*/
_regeneratorRuntime.mark(rootSaga);

import { fork, takeEvery } from 'redux-saga/effects';
import { LOAD_VIEWMODEL_STATE_REQUEST, LOAD_READMODEL_STATE_REQUEST, SEND_COMMAND_REQUEST, AUTH_REQUEST, LOGOUT } from './action_types';
import loadViewModelStateSaga from './load_view_model_state_saga';
import loadReadModelStateSaga from './load_read_model_state_saga';
import sendCommandSaga from './send_command_saga';
import viewModelSaga from './view_models_saga';
import readModelSaga from './read_models_saga';
import subscribeSaga from './subscribe_saga';
import authSaga from './auth_saga';
import logoutSaga from './logout_saga';

function rootSaga(sagaArgs) {
  return _regeneratorRuntime.wrap(function rootSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return fork(subscribeSaga, sagaArgs);

        case 2:
          _context.next = 4;
          return takeEvery(LOAD_VIEWMODEL_STATE_REQUEST, loadViewModelStateSaga, sagaArgs);

        case 4:
          _context.next = 6;
          return takeEvery(LOAD_READMODEL_STATE_REQUEST, loadReadModelStateSaga, sagaArgs);

        case 6:
          _context.next = 8;
          return takeEvery(SEND_COMMAND_REQUEST, sendCommandSaga, sagaArgs);

        case 8:
          _context.next = 10;
          return takeEvery(AUTH_REQUEST, authSaga, sagaArgs);

        case 10:
          _context.next = 12;
          return takeEvery(LOGOUT, logoutSaga, sagaArgs);

        case 12:
          _context.next = 14;
          return fork(viewModelSaga, sagaArgs);

        case 14:
          _context.next = 16;
          return fork(readModelSaga, sagaArgs);

        case 16:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, this);
}

export default rootSaga;
//# sourceMappingURL=root_saga.js.map