"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = createReadModelsReducer;
exports.dropKey = void 0;

var _objectSpread12 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _get_hash = _interopRequireDefault(require("./get_hash"));

var _action_types = require("./action_types");

var _constants = require("./constants");

var dropKey = function dropKey(state, key) {
  var nextState = (0, _objectSpread12.default)({}, state);
  delete nextState[key];
  return nextState;
};

exports.dropKey = dropKey;

function createReadModelsReducer() {
  var _state;

  var handlers = {};

  handlers[_action_types.LOAD_READMODEL_STATE_REQUEST] = function (state, action) {
    var _objectSpread2, _objectSpread3;

    var readModelName = action.readModelName;
    var resolverName = (0, _get_hash.default)(action.resolverName);
    var resolverArgs = (0, _get_hash.default)(action.resolverArgs);
    return (0, _objectSpread12.default)({}, state, (_objectSpread3 = {}, _objectSpread3[_constants.connectorMetaMap] = (0, _objectSpread12.default)({}, state[_constants.connectorMetaMap], (_objectSpread2 = {}, _objectSpread2["" + readModelName + resolverName + resolverArgs] = {
      isLoading: true,
      isFailure: false
    }, _objectSpread2)), _objectSpread3));
  };

  handlers[_action_types.LOAD_READMODEL_STATE_SUCCESS] = function (state, action) {
    var _objectSpread4, _objectSpread5, _objectSpread6, _objectSpread7;

    var readModelName = action.readModelName;
    var resolverName = (0, _get_hash.default)(action.resolverName);
    var resolverArgs = (0, _get_hash.default)(action.resolverArgs);
    var readModelState = action.result;
    var key = "" + readModelName + resolverName + resolverArgs;
    return (0, _objectSpread12.default)({}, state, (_objectSpread7 = {}, _objectSpread7[readModelName] = (0, _objectSpread12.default)({}, state[readModelName] || {}, (_objectSpread5 = {}, _objectSpread5[resolverName] = (0, _objectSpread12.default)({}, (state[readModelName] || {})[resolverName] || {}, (_objectSpread4 = {}, _objectSpread4[resolverArgs] = readModelState, _objectSpread4)), _objectSpread5)), _objectSpread7[_constants.connectorMetaMap] = (0, _objectSpread12.default)({}, state[_constants.connectorMetaMap], (_objectSpread6 = {}, _objectSpread6[key] = {
      isLoading: false,
      isFailure: false
    }, _objectSpread6)), _objectSpread7));
  };

  handlers[_action_types.LOAD_READMODEL_STATE_FAILURE] = function (state, action) {
    var _objectSpread8, _objectSpread9;

    var readModelName = action.readModelName;
    var resolverName = (0, _get_hash.default)(action.resolverName);
    var resolverArgs = (0, _get_hash.default)(action.resolverArgs);
    var error = action.error;
    var key = "" + readModelName + resolverName + resolverArgs;
    return (0, _objectSpread12.default)({}, state, (_objectSpread9 = {}, _objectSpread9[_constants.connectorMetaMap] = (0, _objectSpread12.default)({}, state[_constants.connectorMetaMap], (_objectSpread8 = {}, _objectSpread8[key] = {
      isLoading: false,
      isFailure: true,
      error: error
    }, _objectSpread8)), _objectSpread9));
  };

  handlers[_action_types.DROP_READMODEL_STATE] = function (state, action) {
    var _objectSpread10, _objectSpread11;

    var readModelName = action.readModelName;
    var resolverName = (0, _get_hash.default)(action.resolverName);
    var resolverArgs = (0, _get_hash.default)(action.resolverArgs);
    var key = "" + readModelName + resolverName + resolverArgs;
    return (0, _objectSpread12.default)({}, state, (_objectSpread11 = {}, _objectSpread11[readModelName] = (0, _objectSpread12.default)({}, state[readModelName], (_objectSpread10 = {}, _objectSpread10[resolverName] = dropKey(state[readModelName][resolverName], resolverArgs), _objectSpread10)), _objectSpread11[_constants.connectorMetaMap] = dropKey(state[_constants.connectorMetaMap], key), _objectSpread11));
  };

  var state = (_state = {}, _state[_constants.connectorMetaMap] = {}, _state);
  return function (_, action) {
    var eventHandler = handlers[action.type];

    if (eventHandler) {
      state = eventHandler(state, action);
    }

    return state;
  };
}
//# sourceMappingURL=create_read_models_reducer.js.map