"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _effects = require("redux-saga/effects");

var _action_types = require("./action_types");

var _load_view_model_state_saga = _interopRequireDefault(require("./load_view_model_state_saga"));

var _load_read_model_state_saga = _interopRequireDefault(require("./load_read_model_state_saga"));

var _send_command_saga = _interopRequireDefault(require("./send_command_saga"));

var _view_models_saga = _interopRequireDefault(require("./view_models_saga"));

var _read_models_saga = _interopRequireDefault(require("./read_models_saga"));

var _subscribe_saga = _interopRequireDefault(require("./subscribe_saga"));

var _auth_saga = _interopRequireDefault(require("./auth_saga"));

var _logout_saga = _interopRequireDefault(require("./logout_saga"));

var _marked =
/*#__PURE__*/
_regenerator.default.mark(rootSaga);

function rootSaga(sagaArgs) {
  return _regenerator.default.wrap(function rootSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return (0, _effects.fork)(_subscribe_saga.default, sagaArgs);

        case 2:
          _context.next = 4;
          return (0, _effects.takeEvery)(_action_types.LOAD_VIEWMODEL_STATE_REQUEST, _load_view_model_state_saga.default, sagaArgs);

        case 4:
          _context.next = 6;
          return (0, _effects.takeEvery)(_action_types.LOAD_READMODEL_STATE_REQUEST, _load_read_model_state_saga.default, sagaArgs);

        case 6:
          _context.next = 8;
          return (0, _effects.takeEvery)(_action_types.SEND_COMMAND_REQUEST, _send_command_saga.default, sagaArgs);

        case 8:
          _context.next = 10;
          return (0, _effects.takeEvery)(_action_types.AUTH_REQUEST, _auth_saga.default, sagaArgs);

        case 10:
          _context.next = 12;
          return (0, _effects.takeEvery)(_action_types.LOGOUT, _logout_saga.default, sagaArgs);

        case 12:
          _context.next = 14;
          return (0, _effects.fork)(_view_models_saga.default, sagaArgs);

        case 14:
          _context.next = 16;
          return (0, _effects.fork)(_read_models_saga.default, sagaArgs);

        case 16:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, this);
}

var _default = rootSaga;
exports.default = _default;
//# sourceMappingURL=root_saga.js.map